// AR - this is the now fixed, see line 198




//===============================================================//
function onTimeUpdate(e) {

  if(repeatA > 0 && repeatB > 0){


    var delta = Math.max(0.5, 0.5 * this.playbackRate);
    if(this.currentTime >= repeatB - delta){
      this.currentTime = repeatA;
    }
    return;
  }

  var delta = Math.max(1, 0.5 * this.playbackRate);
  if(this.currentTime >= this.duration - delta){
    this.currentTime = 1;
  }
}







//===============================================================//
function createXButton($box, onClick) {
  var $button = $box.querySelector('button');
  $button.onclick = onClick;

  $button.onmouseover = function () {
    with (this.previousElementSibling.classList){
      remove('hidden');
      remove('invisible');
      add('visible');
    }
  };
  $button.onmouseout = function () {
    with (this.previousElementSibling.classList){
      add('hidden');
      add('invisible');
      remove('visible');
    }
  };

  return $button;
}








//===============================================================//
function createRepeatButton(video) {
  var $box = document.createElement('div');
  $box.className = 'box';

  var html = '';
  html += '<style>';
  html += 'html .player .repeat-button { color: white; font-weight: bold; }\n';
  html += 'html .player .repeat-button.on { background-color: #1ab7ea; }\n';
  html += 'html .player .repeat-button.on:active { background-color: #1E90FF; }\n';
  html += '</style>';
  html += '<label class="rounded-box repeat-label invisible hidden" role="presentation"><span>Repeat</span></label>';
  html += '<button title="Click to toggle." tabindex="50" class="repeat-button rounded-box" aria-label="Repeat">REP&#8203;EAT</button>';
  $box.innerHTML = html;

  var $button = createXButton($box, function (e) {
    var repeating = this.classList.toggle('on');
    if(repeating){
      video.addEventListener('timeupdate', onTimeUpdate);
    }
    else{
      video.removeEventListener('timeupdate', onTimeUpdate);
    }
  });

  return $box;
}







//===============================================================//
var _counter = 0;
var repeatA = 0;
var repeatB = 0;

function createRepeatABButton(video) {
  var $box = document.createElement('div');
  $box.className = 'box';

  var html = '';
  html += '<style>';
  html += 'html .player .repeat-button { color: white; font-weight: bold; }\n';
  html += 'html .player .repeat-button.active-b { background-color: #00e600; }\n';
  html += 'html .player .repeat-button.active-a { background-color: #1E90FF; }\n';
  html += '</style>';
  html += '<label class="rounded-box repeat-label invisible hidden" role="presentation"><span>Click once to record the "A" time. Click a second time to record the "B" time. It will then repeat in the 2 times that was recorded.</span></label>';
  html += '<button title="Repeat A-B" tabindex="50" class="repeat-button rounded-box" aria-label="Repeat A-B">A-B</button>';
  $box.innerHTML = html;

  var $button = createXButton($box, function (e) {
    var repeating = false;
    if(_counter == 0){
      repeatA = video.currentTime;
      _counter++;
      this.classList.add('active-a');
      repeating = false;
    } else if(_counter == 1){
      repeatB = video.currentTime;
      _counter++;
      repeating = true;
      this.classList.remove('active-a');
      this.classList.add('active-b');
      if(repeatB<repeatA){
        repeatA = 0;
        repeatB = 0
        _counter = 0;
        repeating = false;
        this.classList.remove('active-b');
      }
    } else{
      repeatA = 0;
      repeatB = 0
      _counter = 0;
      repeating = false;
      this.classList.remove('active-b');
    }
    if(repeating){
      video.addEventListener('timeupdate', onTimeUpdate);
    }
    else{
      video.removeEventListener('timeupdate', onTimeUpdate);
    }
  });

  return $box;
}

//===============================================================//
function createSpeedButton(video) {
  var $box = document.createElement('div');
  $box.className = 'box';

  var html = '';
  html += '<style>';
  html += 'html .player .speed-button { color: white; font-weight: bold; } \n';
  html += 'html .player .speed-button.on { background-color: #1ab7ea; } \n';
  html += 'html .player .speed-button.on:active { background-color: #1ab7ea; } \n';
  html += '</style>';
  html += '<label class="rounded-box speed-label invisible hidden" role="presentation"><span>Playback rate. Change the speed that the video plays.</span></label>';
  html += '<button title="Use the scroll on the mouse to change speed and hit enter." tabindex="50" class="speed-button rounded-box" aria-label="Speed">' + video.playbackRate + 'x</button>';
  $box.innerHTML = html;

  function setSpeed(speed) {
    video.playbackRate = speed;
    $button.textContent = (Math.round(speed * 100) / 100) + 'x';

    if(video.playbackRate == 1){
      $button.classList.remove('on');
    }
    else{
      $button.classList.add('on');
    }
  }

  var $button = createXButton($box, function (e) {
    var curSpeed = video.playbackRate,
      newSpeed = prompt('New playback rate:', curSpeed);
    if(newSpeed != null && Number(newSpeed) == newSpeed && newSpeed != curSpeed){
      setSpeed(newSpeed);
    }
  });
  $button.onmousewheel = function (e) {
    var speeds = [0.2, 0.3333, 0.5, 0.6666, 1, 1.25, 1.5, 2, 2.5, 3, 4];

    e.preventDefault();

    var direction = e.wheelDelta / Math.abs(e.wheelDelta); // up = 1, down = -1
    var curSpeed = video.playbackRate,
      curSpeedIndex = speeds.indexOf(curSpeed);

    // On the scale, so find next by index
    if(curSpeedIndex != -1){
      if(speeds[curSpeedIndex + direction]){
        setSpeed(speeds[curSpeedIndex + direction]);
      }
    }
    else{
      var candidates = speeds.filter(function (speed) {
        return direction > 0 ? (speed > curSpeed) : (speed < curSpeed);
      });
      if(candidates.length){
        var newSpeed = direction > 0 ? candidates[0] : candidates[candidates.length - 1];
        setSpeed(newSpeed);
      }
    }
  };

  return $box;
}







// AR - was getting double buttons, I got the OTHER dudes code below
//===============================================================//
// var $player = document.querySelector('div.player');
// 
// if($player){
// 
//   var mo = new MutationObserver(function (muts) {
//     setTimeout(function () {
//       var video = $player.querySelector('video');
// 
//       var $buttons = $player.querySelector('.vp-controls-wrapper .vp-sidedock, .controls-wrapper .sidedock');
// 
//       if($buttons){
//         var $box = createRepeatButton(video);
//         $buttons.appendChild($box);
// 
//         var $box = createSpeedButton(video);
//         $buttons.appendChild($box);
// 
// 
//         var $box = createRepeatABButton(video);
//         $buttons.appendChild($box);
// 
//       }
//     }, 1);
//   });
//   mo.observe($player, {"childList": 1})
// }




// seeing if this guy wrote better code, yes only single buttons
// I added the AB button
function tryToInitPlayer(attemptsLeft, $player) {
	var $buttons = $player.querySelector('.vp-controls-wrapper .vp-sidedock, .controls-wrapper .sidedock');
	var $video = $player.querySelector('video');

	if ( $player && $buttons && $video ) {
		// Only do once!
		if ( !$buttons.querySelector('.repeat-button') ) {
			console.debug('[Vimeo Repeat] Adding buttons');

			// Add REPEAT button
			var $box = createRepeatButton($video);
			$buttons.appendChild($box);

			// Add SPEED button
			var $box = createSpeedButton($video);
			$buttons.appendChild($box);
			
			
			//  AR Add A/B button
			var $box = createRepeatABButton($video);
			$buttons.appendChild($box);
		}
	}
	else {
		console.debug(`[Vimeo Repeat] Can't find buttons (${$buttons ? 'Y' : 'N'}), or video (${$video ? 'Y' : 'N'}). Trying ${attemptsLeft} more times.`);
		if ( attemptsLeft > 0 ) {
			setTimeout(function() {
				tryToInitPlayer(--attemptsLeft, $player);
			}, 50);
		}
	}
}



var $player = document.querySelector('div.player');
if ( $player ) {
	var mo = new MutationObserver(function(muts) {
		// Try to find buttons menu & video element
		tryToInitPlayer(2, $player);
	});
	mo.observe($player, {"childList": true, "attributes": true});
}
